import { useState } from "react";
import { Entity, PointGraphics, useCesium } from "resium";
import { useInterval } from "ahooks";
import {
  Cartesian3,
  Color,
  JulianDate,
  LagrangePolynomialApproximation,
  PolylineDashMaterialProperty,
  SampledPositionProperty,
  TimeInterval,
  TimeIntervalCollection,
  VelocityOrientationProperty,
} from "cesium";

// 从拉布拉多海到青藏高原
const dataLabToQTP = [
  { longitude: -62, latitude: 69, height: 1000000, time: 5 },
  { longitude: -20, latitude: 55, height: 1000000, time: 10 },
  { longitude: 29, latitude: 49, height: 1000000, time: 15 },
  { longitude: 62, latitude: 45, height: 1000000, time: 20 },
  { longitude: 98, latitude: 48, height: 1000000, time: 25 },
];

function Point() {
  const { viewer } = useCesium();
  const [delay, setDelay] = useState(1000);

  const start = viewer.clock.startTime;
  const stop = viewer.clock.stopTime;

  const pathMaterial = new PolylineDashMaterialProperty({
    dashLength: 20,
    color: new Color(4 / 255, 251 / 255, 253 / 255),
  });

  useInterval(() => {
    if (viewer.clock?.shouldAnimate) setDelay(undefined);
  }, delay);

  /**
   * 计算飞行路径
   * 数据坐标
   * {SampledPositionProperty|*}
   */
  function createProperty(source) {
    let property = new SampledPositionProperty();
    for (let i = 0; i < source.length; i++) {
      let time = JulianDate.addSeconds(start, source[i].time, new JulianDate());
      let position = Cartesian3.fromDegrees(
        source[i].longitude,
        source[i].latitude,
        source[i].height
      );
      // 添加位置，和时间对应
      property.addSample(time, position);
    }
    property.setInterpolationOptions({
      interpolationDegree: 10,
      interpolationAlgorithm: LagrangePolynomialApproximation,
    });

    return property;
  }

  const property = createProperty(dataLabToQTP);

  return (
    <Entity
      id={"point"}
      position={property}
      availability={
        new TimeIntervalCollection([
          new TimeInterval({
            start: start,
            stop: stop,
          }),
        ])
      }
      orientation={new VelocityOrientationProperty(property)}
      path={{
        resolution: 1,
        material: pathMaterial,
        // leadTime、trailTime 不设置 path全显示
        leadTime: 0, // 设置为0时 模型通过后显示path
        // trailTime: 0, // 设置为0时 模型通过后隐藏path
        width: 2,
      }}
    >
      <PointGraphics
        show={true}
        color={Color.SKYBLUE}
        pixelSize={10}
        outlineColor={Color.YELLOW}
        outlineWidth={3}
      />
    </Entity>
  );
}

export default Point;
